package org.mandarax.xkb.framework;

/**
 *  Copyright (C) 1999-2004  Jens Dietrich (mailto:mandarax@jbdietrich.com)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.util.Map;

import javax.sql.DataSource;

import org.jdom.Element;
import org.mandarax.kernel.LogicFactory;
import org.mandarax.sql.SQLFunction;
import org.mandarax.sql.SQLObjectRelationalMapping;
import org.mandarax.xkb.XKBException;
/**
 * An adapter class for sql functions.
 * New is the support for the close connection property.
 * @see org.mandarax.sql.SQLFunction
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 2.0 
 */

public class XMLAdapter4SQLFunctions2 extends AbstractXMLAdapter {
      public static final String SQL_FUNCTION = "sql_function";
      public static final String NAME = "name";
      public static final String QUERY = "query";
      public static final String STRUCTURE = "structure";
      public static final String MAPPING = "mapping";
      public static final String CLOSE_CONNECTION = "close_connection";
/**
 * Export an object, i.e., convert it to an element in the DOM.
 * @param obj an object
 * @param driver the generic driver
 * @param cache a cache used in order to associate the same
 * id with various occurences of the same object
 * @exception an XKBException is thrown if export fails
 */
public Element exportObject(Object obj,GenericDriver driver,Map cache) throws  XKBException {
      check(obj,SQLFunction.class);
      SQLFunction f = (SQLFunction)obj;
      Element e = new Element(SQL_FUNCTION);
      // add name and query
      e.setAttribute(NAME,f.getName());
      e.setAttribute(QUERY,f.getQuery());
      e.setAttribute(CLOSE_CONNECTION,f.isCloseConnection()?"true":"false");

      // add structure
      Element es = new Element(STRUCTURE);
      e.addContent(es);
      exportChildren(f.getStructure(),es,GenericDriver.TYPE,driver,cache);

      // add mapping (use object adapter)
      Element em = new Element(MAPPING);
      e.addContent(em);
      Element eo = exportObject(f.getObjectRelationalMapping(),GenericDriver.OBJECT,driver,cache);
      em.addContent(eo);
      // add data source
      Element ed = exportObject(f.getDataSource(),GenericDriver.DATA_SOURCE,driver,cache);
      e.addContent(ed);

      return e;
}
/**
 * Build an object from an XML element.
 * @param e an element
 * @param driver the generic driver
 * @param cache a cache used to identify objects that have the same id
 * @param lfactory the logic factory used to create objects
 * @exception an XKBException is thrown if import fails
 */
public Object importObject(Element e,GenericDriver driver,Map cache,LogicFactory lfactory) throws XKBException {
      // get query and name
      String query = e.getAttributeValue(QUERY);
      String name = e.getAttributeValue(NAME);
      // get structure
      Element eStruct = e.getChild(STRUCTURE);
      Class[] structure = (Class[])importChildren(eStruct,null,driver,cache,lfactory,Class.class);
      // get mapping
      Element eMap = e.getChild(MAPPING);
      SQLObjectRelationalMapping map = (SQLObjectRelationalMapping)importChild(eMap,GenericDriver.OBJECT,driver,cache,lfactory);

      // get data source
      Element eDatasource = (Element)e.getChildren().get(2);
      XMLAdapter adapter = driver.getAdapterByTagName(eDatasource.getName());
      DataSource ds = (DataSource)adapter.importObject(eDatasource,driver,cache,lfactory);

      // build function
      SQLFunction function = new SQLFunction();
      function.setDataSource(ds);
      function.setName(name);
      function.setQuery(query);
      function.setCloseConnection("true".equals(e.getAttributeValue(CLOSE_CONNECTION)));
      function.setObjectRelationalMapping(map);
      function.setStructure(structure);
      return function;

}
/**
 * Get the name of the associated tag (element).
 * @return a string
 */
public String getTagName() {
      return SQL_FUNCTION;
}
/**
 * Get the kind of object the adapter can export/import.
 * @return a string
 */
public String getKindOfObject() {
      return GenericDriver.SQL_FUNCTION;
}
}
